;; Copyright (C) 2001 Red Hat, Inc.
;;
;; lang-dependent dot.emacs functions for Red Hat Linux
;;  Ver:    2001-01-18
;;  Maintainer: Yukihiro Nakai <ynakai@redhat.com>
;;

;; function name: suffix-cut-from
;;   Cuts str after mychar and return.
;;   Returns nil when mychar is not in str.
(defun suffix-cut-from (str mychar)
  (let ((ret nil)
        (counter 0))
    (while (< counter (length str))
      (if (string= (substring str counter (1+ counter)) mychar)
	  (setq ret counter))
      (setq counter (1+ counter)))
    (if ret
	(setq ret (substring str 0 ret)))
    ret))

;; Test cases for suffix-cut-from
;; (eval (suffix-cut-from ("ja_JP.eucJP", "."))
;; (eval (suffix-cut-from ("ja_JP.eucJP", "_")))
;; (eval (suffix-cut-from ("ja_JP.eucJP", "nonexit")
;;

;; Where is the system dot-emacs for languages
(let ((system-dot-emacs "/usr/share/emacs/site-lisp/lang/lang")
      (lang (getenv "LANG"))
      (dot-cands-list nil))
  ;; Exactly match ( i.e. filename.ja_JP.eucJP )
  (setq dot-cands-list (list (concat system-dot-emacs "-" lang ".el")))
  ;; Without codeset match ( i.e. filename.ja_JP )
  (if (stringp (suffix-cut-from lang "."))
      (setq dot-cands-list
	    (append dot-cands-list
		    (list (concat system-dot-emacs "-"
				  (suffix-cut-from lang ".") ".el")))))
  ;; Just language name ( i.e. filename.ja )
  (if (stringp (suffix-cut-from lang "_"))
      (setq dot-cands-list
	    (append dot-cands-list
		    (list (concat system-dot-emacs "-"
				  (suffix-cut-from lang "_") ".el")))))
  ;; Default
  (setq dot-cands-list
	(append dot-cands-list (list (concat system-dot-emacs ".el"))))
  ;;(append dot-cands-list)
  
  (while (consp dot-cands-list)
    (if (file-readable-p (car dot-cands-list))
	(prog1 (load-file (car dot-cands-list)) (setq dot-cands-list nil))
      (setq dot-cands-list (cdr dot-cands-list)))
    )
  )
